// This class was created by JaTiTV.

package net.t2code.alias.Spigot.config.subAlias;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Spigot.config.ConfigFileConverter;
import net.t2code.alias.Spigot.config.config.Config;
import net.t2code.alias.Spigot.objects.SubAliasObject;
import net.t2code.alias.util.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;

import java.io.File;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

public class SubAliasFile {

    public enum VALUES implements T2C_ConfigItem {
        aliasEnable("subAlias.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du den Alias deaktivieren."));
                    put(T2C_LanguageEnum.english, List.of("Here you can disable the alias."));
                }}),
        subAliasList("subAlias.subAliasList", List.of("subaliasexample1"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Gib hier an, wie die SubAlias-Befehle für diese Funktion lauten sollen"));
                    put(T2C_LanguageEnum.english, List.of("Specify here what the SubAlias commands should be for this function"));
                }}),
        subAliasFor("subAlias.subAliasFor", "aliasexample1", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Gib hier den Alias-Befehl ein, dem die Subalias folgen sollen.","Zum Beispiel:","  - aliasexample1 -> aliasexample1 <this SubAlias>","  - aliasexample2 test -> aliasexample2 test <this SubAlias>"));
                    put(T2C_LanguageEnum.english, List.of("Enter here the alias command where the subalias should follow.","For example:","  - aliasexample1 -> aliasexample1 <this SubAlias>","  - aliasexample2 test -> aliasexample2 test <this SubAlias>"));
                }}),

        permNecessary("subAlias.permission.necessary", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du angeben, ob für die Verwendung des Alias eine Erlaubnis erforderlich ist."));
                    put(T2C_LanguageEnum.english, List.of("Here you can say if a permission is needed to use the alias."));
                }}),
        permission("subAlias.permission.permission", "t2c.alias.sub.use.[alias]", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du die Berechtigung für den Alias festlegen.", "Der Platzhalter <alias> ist der Alias-Name.", "Wenn du mehrere Alias Commands in der Liste 'subAlias.subAliasList' festgelegt hast, hast du für jeden Alias eine Berechtigung."));
                    put(T2C_LanguageEnum.english, List.of("Here you can set the permission for the alias.", "The placeholder <alias> is the alias name.", "If you have set multiple alias referrers in the list 'subAlias.subAliasList' you have a permission for each alias."));
                }}),
        permissionMSG("subAlias.permission.customNoPermissionMSG", "", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du eine benutzerdefinierte Nicht-Erlaubnis-Meldung für diesen Alias festlegen. Wenn du die Standardmeldung verwenden willst, lass dieses Feld einfach leer."));
                    put(T2C_LanguageEnum.english, List.of("Here you can set a custom No Permission message for this alias. If you want to use the default message, just leave this blank."));
                }}),

        cooldownGlobal("subAlias.cooldownInSec.global", 0, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du eine globale Abklingzeit für diesen Alias festlegen.", "Der Wert entspricht den Sekunden.", "Bei 0 ist die Abklingzeit deaktiviert.", "Der Platzhalter [alias] ist der Name des Alias.", "Bypass permission: t2c.alias.cooldown.global.[alias].bypass", "(Die globale Abklingzeit ist höher als die Abklingzeit des Spielers)."));
                    put(T2C_LanguageEnum.english, List.of("Here you can set a global cooldown for this alias.", "The value corresponds to the seconds.", "At 0, the cooldown is deactivated.", "The placeholder [alias] is the alias name.", "Bypass permission: t2c.alias.cooldown.global.[alias].bypass", "(The global cooldown is above the player cooldown)."));
                }}),
        cooldownPlayer("subAlias.cooldownInSec.player", 0, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du eine spielerspezifische Abklingzeit für diesen Alias festlegen.", "Der Wert entspricht den Sekunden.", "Bei 0 ist die Abklingzeit deaktiviert.", "Der Platzhalter [alias] ist der Name des Alias.", "Bypass permission: t2c.alias.cooldown.player.[alias].bypass"));
                    put(T2C_LanguageEnum.english, List.of("Here you can set a player-specific cooldown for this alias.", "The value corresponds to the seconds.", "At 0, the cooldown is deactivated.", "The placeholder [alias] is the alias name.", "Bypass permission: t2c.alias.cooldown.player.[alias].bypass"));
                }}),

        costEnable("subAlias.cost.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du angeben, ob du für den Alias bezahlen musst."));
                    put(T2C_LanguageEnum.english, List.of("Here you can say if you have to pay for the alias."));
                }}),
        costConfirm("subAlias.cost.confirm", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du einstellen, ob du vor dem Ausführen des Befehls bestätigen musst, ob du bezahlen willst", "In der config.yml kannst du unter 'buy.confirm.use' einstellen, ob ein Befehl, ein chatListener oder eine GUI zur Bestätigung des Befehls verwendet werden soll."));
                    put(T2C_LanguageEnum.english, List.of("Here you can set if you have to confirm if you want to pay before executing the command", "In the config.yml you can set under 'buy.confirm.use' if a command, a chatListener or a GUI should be used to confirm the command."));
                }}),
        costPrice("subAlias.cost.price", 0.0, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier legst du den Preis fest."));
                    put(T2C_LanguageEnum.english, List.of("Here you set the price."));
                }}),
        costAllowBypass("subAlias.cost.allowByPass", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier legst du fest, ob der Bypass aktiviert ist oder ob du trotz des Bypasses zahlen musst (t2c.alias.buy.[alias].bypass)."));
                    put(T2C_LanguageEnum.english, List.of("Here you define if the bypass is activated or if you have to pay despite the bypass (t2c.alias.buy.[alias].bypass)."));
                }}),

        commandEnable("subAlias.command.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du dem Alias mitteilen, dass er einen oder mehrere Befehle ausführen soll"));
                    put(T2C_LanguageEnum.english, List.of("Here you can tell the alias to execute one or more commands"));
                }}),
        commandAsConsole("subAlias.command.commandAsConsole", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du angeben, ob der Befehl über die Konsole des Servers ausgeführt werden soll"));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the command should be executed from the console of the server"));
                }}),
        bungeeCommand("subAlias.command.proxyCommand", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du festlegen, ob der Befehl auf dem Proxy ausgeführt werden soll.", "Damit diese Funktion funktioniert, muss die T2CodeLib auf deinem Proxy vorhanden sein und die API für T2C-OPSecurity muss in seiner Konfiguration aktiviert sein!", "(Wenn sie von der Proxy-Konsole aus ausgeführt werden soll, muss die Option CommandAsConsole ebenfalls aktiviert sein)"));
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the command should be executed on the proxy.", "For this function to work, the T2CodeLib must be present on your proxy and the API for T2C-OPSecurity must be activated in its config!", "(If it is to be executed from the proxy console, the CommandAsConsole option must also be enabled)"));
                }}),
        command("subAlias.command.commands", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du einen oder mehrere Befehle angeben, die ausgeführt werden sollen.", "Placeholder: [player] = Der Spieler, der den Alias ausführt"));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify one or more commands to be executed.", "Placeholder: [player] = The player who executes the alias"));
                }}),

        messageEnable("subAlias.message.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du angeben, ob der Spieler eine Nachricht erhalten soll."));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the player should receive a message."));
                }}),

        messages("subAlias.message.messages", List.of("This is a test subvcommand of T2C-Alias."), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Gib hier die Nachricht an, die der Spieler erhalten soll.", "Gib hier die Nachricht an, die der Spieler erhalten soll.", "Placeholder: [player] = Der Spieler, der den Alias ausführt", "#", "Du kannst die Minecraft eigenen Farbcodes verwenden: https://minecraft.fandom.com/de/wiki/Formatierungscodes", "Du kannst auch MiniMessage verwenden:", "  Wiki: https://docs.adventure.kyori.net/minimessage/format.html", "  WebUI: https://webui.adventure.kyori.net"));
                    put(T2C_LanguageEnum.english, List.of("Specify here the message that the player should get.", "Multiple lines can be used and placeholders are supported!", "Placeholder: [player] = The player who executes the alias", "#", "You can use Minecraft custom color codes: https://minecraft.fandom.com/de/wiki/Formatierungscodes", "You can also use MiniMessage:", "  Wiki: https://docs.adventure.kyori.net/minimessage/format.html", "  WebUI: https://webui.adventure.kyori.net"));
                }}),

        admin("subAlias.admin", null, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du festlegen, dass Spieler mit der (in der Option subAlias.admin.permission angegebenen) Erlaubnis eine andere Funktion haben als andere Spieler.", "Du kannst z.B. sagen, dass Spieler zu einem bestimmten Punkt kommen sollen und Spieler mit der Admin-Funktion nur auf dem Server zu der Position kommen sollen, wo sie vorher waren.", "Beispiel:", "Spieler: /warp CityBuild", "Spieler mit Admin Permission: /server CityBuild"));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify that players with the permission (specified in the subAlias.admin.permission option) have a different function than other players.", "For example, you can say that players should come to a certain point and players with the admin function only to the server to the position where they were before.", "Example:", "Player: /warp CityBuild", "Player with Admin Perm: /server CityBuild"));
                }}),
        adminEnable("subAlias.admin.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du die Admin-Funktion aktivieren oder deaktivieren"));
                    put(T2C_LanguageEnum.english, List.of("Here you can enable or disable the admin function"));
                }}),

        adminPermission("subAlias.admin.permission", "t2c.alias.[alias].admin", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier legst du die Berechtigung für die Admin-Funktion fest","Der Platzhalter [alias] ist der Name des Alias.","Wenn du mehrere Alias-Referrer in der Liste 'subAlias.subAliasList' festgelegt hast, hast du für jeden Alias eine Berechtigung."));
                    put(T2C_LanguageEnum.english, List.of("Here you set the permission for the admin function","The placeholder [alias] is the alias name.","If you have set multiple alias referrers in the list 'subAlias.subAliasList' you have a permission for each alias."));
                }}),

        adminCommandEnable("subAlias.admin.command.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du dem Alias mitteilen, dass er einen oder mehrere Befehle ausführen soll"));
                    put(T2C_LanguageEnum.english, List.of("Here you can tell the alias to execute one or more commands"));
                }}),

        adminCommandAsConsole("subAlias.admin.command.commandAsConsole", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du angeben, ob der Befehl über die Konsole des Servers ausgeführt werden soll"));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the command should be executed from the console of the server"));
                }}),

        adminBungeeCommand("subAlias.admin.command.proxyCommand", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du festlegen, ob der Befehl auf dem Proxy ausgeführt werden soll.", "Damit diese Funktion funktioniert, muss die T2CodeLib auf deinem Proxy vorhanden sein und die API für T2C-Alias muss in seiner Konfiguration aktiviert sein!", "(Wenn sie von der Proxy-Konsole aus ausgeführt werden soll, muss die Option CommandAsConsole ebenfalls aktiviert sein)."));
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the command should be executed on the proxy.", "For this function to work, the T2CodeLib must be present on your proxy and the API for T2C-Alias must be activated in its config!", "(If it is to be executed from the proxy console, the CommandAsConsole option must also be enabled)."));
                }}),

        adminCommands("subAlias.admin.command.commands", Collections.singletonList("say hi"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du einen oder mehrere Befehle angeben, die ausgeführt werden sollen.", "Placeholder: [player] = Symbolleiste anpassen..."));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify one or more commands to be executed.", "Placeholder: [player] = The player who executes the alias"));

                }}),

        adminMessageEnable("subAlias.admin.message.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du angeben, ob der Spieler eine Nachricht erhalten soll."));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the player should receive a message."));
                }}),

        adminMessages("subAlias.admin.message.messages", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Gib hier die Nachricht an, die der Spieler erhalten soll.", "Es können mehrere Zeilen verwendet werden und Platzhalter werden unterstützt!", "Placeholder: [player] = Der Spieler, der den Alias ausführt", "#", "Du kannst die Minecraft eigenen Farbcodes verwenden:: https://minecraft.fandom.com/de/wiki/Formatierungscodes", "Du kannst auch MiniMessage verwenden:", "  Wiki: https://docs.adventure.kyori.net/minimessage/format.html", "  WebUI: https://webui.adventure.kyori.net"));
                    put(T2C_LanguageEnum.english, List.of("Specify here the message that the player should get.", "Multiple lines can be used and placeholders are supported!", "Placeholder: [player] = The player who executes the alias", "#", "You can use Minecraft custom color codes: https://minecraft.fandom.com/de/wiki/Formatierungscodes", "You can also use MiniMessage:", "  Wiki: https://docs.adventure.kyori.net/minimessage/format.html", "  WebUI: https://webui.adventure.kyori.net"));
                }}),

        consoleEnable("subAlias.console.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du festlegen, ob der Alias auch in der Konsole verwendet werden kann und was er dort tun soll."));
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the alias is also usable in the console and what it should do from there."));
                }}),

        consoleCommandEnable("subAlias.console.command.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du dem Alias mitteilen, dass er einen oder mehrere Befehle ausführen soll"));
                    put(T2C_LanguageEnum.english, List.of("Here you can tell the alias to execute one or more commands"));
                }}),

        consoleBungeeCommand("subAlias.console.command.proxyCommand", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du festlegen, ob der Befehl auf dem Proxy ausgeführt werden soll.", "Damit diese Funktion funktioniert, muss die T2CodeLib auf deinem Proxy vorhanden sein und die API für T2C-Alias muss in seiner Konfiguration aktiviert sein!", "(Wenn sie von der Proxy-Konsole aus ausgeführt werden soll, muss die Option CommandAsConsole ebenfalls aktiviert sein)"));
                    put(T2C_LanguageEnum.english, List.of("Here you can define if the command should be executed on the proxy.", "For this function to work, the T2CodeLib must be present on your proxy and the API for T2C-Alias must be activated in its config!", "(If it is to be executed from the proxy console, the CommandAsConsole option must also be enabled)"));
                }}),

        consoleCommands("subAlias.console.command.commands", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du einen oder mehrere Befehle angeben, die ausgeführt werden sollen."));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify one or more commands to be executed."));
                }}),

        consoleMessageEnable("subAlias.console.message.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du angeben, ob der Spieler eine Nachricht erhalten soll."));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify whether the player should receive a message."));
                }}),

        consoleMessages("subAlias.console.message.messages", List.of(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Gib hier die Nachricht an, die der Spieler erhalten soll."));
                    put(T2C_LanguageEnum.english, List.of("Specify here the message that the player should get."));
                }}),
        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return Config.VALUES.language.getPath();
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "subAlias/subaliasexample.yml"), VALUES.values(), isReload, Util.getConfigLogo());
    }


    public static void select(boolean isReload) {

        ConfigFileConverter.convert();
        File f = new File(Main.getPath() + "/subAlias/");
        File[] fileArray = f.listFiles();
        assert fileArray != null;
        for (File file : fileArray) {
            String sub = file.getName().substring(file.getName().length() - 4);
            if (sub.equals(".yml")) {
                T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "subAlias/" + file.getName()), VALUES.values(), isReload, Util.getConfigLogo());
                for (String s : (List<String>) VALUES.subAliasList.value) {
                    if (s != null) {
                        Main.allSubAliases.add(s);
                    }
                }

                int subAliasArg = 0;
                if (VALUES.subAliasFor.value != null) {
                    Main.allForSubAliases.add((String) VALUES.subAliasFor.value);
                    String[] imp = ((String) VALUES.subAliasFor.value).split(" ");
                    if (!Main.allAliases.contains(imp[0])) {
                        T2C_Send.error(Main.getInstance(), "The alias " + imp[0] + " in the file " + file.getName() + " does not exist!");
                    }
                    String[] args = ((String) VALUES.subAliasFor.value).split(" ");
                    subAliasArg = args.length - 1;
                }

                SubAliasObject subAlias = new SubAliasObject(
                        (boolean) VALUES.aliasEnable.value,
                        (List<String>) VALUES.subAliasList.value,
                        (String) VALUES.subAliasFor.value,
                        subAliasArg,
                        (boolean) VALUES.permNecessary.value,
                        (String) VALUES.permission.value,
                        (String) VALUES.permissionMSG.value,
                        (int) VALUES.cooldownGlobal.value,
                        (int) VALUES.cooldownPlayer.value,
                        (boolean) VALUES.costEnable.value,
                        (boolean) VALUES.costConfirm.value,
                        (double) VALUES.costPrice.value,
                        (boolean) VALUES.costAllowBypass.value,
                        (boolean) VALUES.commandEnable.value,
                        (boolean) VALUES.commandAsConsole.value,
                        (boolean) VALUES.bungeeCommand.value,
                        (List<String>) VALUES.command.value,
                        (boolean) VALUES.messageEnable.value,
                        (List<String>) VALUES.messages.value,
                        (boolean) VALUES.adminEnable.value,
                        (String) VALUES.adminPermission.value,
                        (boolean) VALUES.adminCommandEnable.value,
                        (boolean) VALUES.adminCommandAsConsole.value,
                        (boolean) VALUES.adminBungeeCommand.value,
                        (List<String>) VALUES.adminCommands.value,
                        (boolean) VALUES.adminMessageEnable.value,
                        (List<String>) VALUES.adminMessages.value,
                        (boolean) VALUES.consoleEnable.value,
                        (boolean) VALUES.consoleCommandEnable.value,
                        (boolean) VALUES.consoleBungeeCommand.value,
                        (List<String>) VALUES.consoleCommands.value,
                        (boolean) VALUES.consoleMessageEnable.value,
                        (List<String>) VALUES.consoleMessages.value);
                for (String sal : (List<String>) VALUES.subAliasList.value) {
                    Main.subAliasHashMap.put(sal, subAlias);
                }
            }
        }
    }
}























